﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams.Extensions;

namespace SilverlightApplication45
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			diagram.GraphSource = new ObservableGraphSource();

			var galleryCollection = new Gallery() { Header = "General" };
			var shape = new CustomShape() { Content = "Custom shape", Task = "New Task" };
			galleryCollection.Items.Add(new GalleryItem() { Shape = shape });
			HierarchicalGalleryItemsCollection collection = new HierarchicalGalleryItemsCollection();
			collection.Add(galleryCollection);
			toolbox.ItemsSource = collection;
		}
	}

	public class ObservableGraphSource : ObservableGraphSourceBase<DiagramTask, DiagramConnector>
	{
		public override void AddNode(DiagramTask node)
		{

			if (node.Task == null)
			{						// This is where I'd like to know what image was dropped.
				// but the node (DiagramTask) object  has no values from the Toolbox

			}
			else
			{
 
			}

			base.AddNode(node);
		}
	
		public override object CreateNode(Telerik.Windows.Diagrams.Core.IShape shape)
		{
			var customShape = shape as CustomShape;
			if (shape != null)
				return new DiagramTask() { Task = customShape.Task };
			else return base.CreateNode(shape);
		}
	}


	public class DiagramTask : NodeViewModelBase
	{
		public string Task
		{ get; set; }
	}

	public class DiagramConnector : LinkViewModelBase<DiagramTask>
	{ }

	public class CustomShape : RadDiagramShape
	{
		public string Task
		{
			get;
			set;
		}

		public override Telerik.Windows.Diagrams.Core.SerializationInfo Serialize()
		{
			var info = base.Serialize();
			info["Task"] = this.Task;
			return info;
		}

		public override void Deserialize(Telerik.Windows.Diagrams.Core.SerializationInfo info)
		{
			base.Deserialize(info);
			this.Task = (string)info["Task"];
		}
	}
}
